<?php
/*
Plugin Name: GD LinkedIn Badge
Plugin URI: http://wp.gdragon.info/plugins/gd-linkedin-badge
Description: This widget displays badge with a link to a LinkedIn profile page.
Version: 1.0.0
Author: Milan Petrovic
Author URI: http://wp.gdragon.info/

== Info ==

* change log is available in readme.txt
* to do list is available in readme.txt
  
== Copyright ==

Copyright 2008 Milan Petrovic (email : milan@gdragon.info)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

class GDLinkedInBadge
{
    var $default_options = array(
            'title'=>'LinkedIn', 
            'url'=>'http://www.linkedin.com/in/gdragon/', 
            'text'=>'Milan Petrovic',
            'description'=>'If you want to see my LinkedIn profile, click on this button:',
            'badge'=>0
        );
    var $badges = array (
            array ( 'View Profile 160x33', 'btn_viewmy_160x33.gif' ),
            array ( 'My Profile 160x33', 'btn_myprofile_160x33.gif' ),
            array ( 'View Profile 160x25', 'btn_viewmy_160x25.gif' ),
            array ( 'View Profile 120x33', 'btn_viewmy_120x33.gif' ),
            array ( 'LinkedIn 120x33', 'btn_linkedin_120x30.gif' ),
            array ( 'Profile Grey 80x15', 'btn_profile_greytxt_80x15.gif' ),
            array ( 'Profile Blue 80x15', 'btn_profile_bluetxt_80x15.gif' ),
            array ( 'LinkedIn 80x15', 'btn_liprofile_blue_80x15.gif' )
        );
    
    function GDLinkedInBadge() {
    }
    
    function init() {
        register_sidebar_widget(array('GD LinkedIn Badge', 'widgets'), array($this, 'widget'));
        register_widget_control(array('GD LinkedIn Badge', 'widgets'), array($this, 'control'), 250, 470);
    }
    
    function widget($args) {
        extract($args);
        $options = get_option('widget_gdlinkedinbadge');
        
        $title = trim($options['title']);
        $text = $options['text'];
        $description = $options['description'];
        $url = $options['url'];
        $badge = $options['badge'];

        echo $before_widget;
        if ($title != "") 
            echo $before_title.$title.$after_title;
        if ($description != "") 
            echo '<p style="text-align: center">'.$description.'</p>';
        echo $this->make_badge($badge, $url, $text);
        echo $after_widget;
    }
    
    function control() {
        $options = get_option('widget_gdlinkedinbadge');
        if (!is_array($options)) {
            $options = $this->default_options;
        }
        
        if ($_POST['gdlb-submit']) {
            $options['title'] = strip_tags(stripslashes($_POST['gdlb-title']));
            $options['url'] = $_POST['gdlb-url'];
            $options['text'] = $_POST['gdlb-text'];
            $options['description'] = $_POST['gdlb-description'];
            $options['badge'] = $_POST['gdlb-badge'];
            
            update_option('widget_gdlinkedinbadge', $options);
        }
        
        $title = $options['title'];
        $text = $options['text'];
        $description = $options['description'];
        $url = $options['url'];
        $badge = $options['badge'];

        $gdlb_js_items = "";
        for ($i = 0; $i < count($this->badges); $i++) {
            $gdlb_js_items.="'".$this->badges[$i][1]."'";
            if ($i<count($this->badges)-1) $gdlb_js_items.=",";
        }
        
?>
        <script>
            function gdlbImageSelection(index) {
                var gdlbAllImages = [ <?php echo $gdlb_js_items; ?> ];
                var gdlbImage = document.getElementById("gdlb-badge-image");
                gdlbImage.src = "http://www.linkedin.com/img/webpromo/" + gdlbAllImages[index];
            }
        </script>
        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Title:</legend>
            <input class="widefat" style="width: 97%;" id="gdlb-title" name="gdlb-title" type="text" value="<?php echo $title; ?>" />
        </fieldset>

        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Settings:</legend>
            <label for="gdlb-text">Text:</label>
            <br /><input class="widefat" style="width: 97%;" id="gdlb-text" name="gdlb-text" type="text" value="<?php echo $text; ?>" />
            <label for="gdlb-description">Description:</label>
            <br /><input class="widefat" style="width: 97%;" id="gdlb-description" name="gdlb-description" type="text" value="<?php echo $description; ?>" />
            <label for="gdlb-url">LinkedIn URL:</label>
            <br /><input class="widefat" style="width: 97%;" id="gdlb-url" name="gdlb-url" type="text" value="<?php echo $url; ?>" />
        </fieldset>

        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Badge Style:</legend>
            <select style="width: 100%;" name="gdlb-badge" id="gdlb-badge" onchange="gdlbImageSelection(this.options[this.selectedIndex].value)"><?php $this->make_options($badge) ?></select>
            <div align="center" style="width:100%; padding-top:5px;"><img id="gdlb-badge-image" src="#" border="0" /></div>
        </fieldset>
        <br />
        <input type="hidden" id="gdlb-submit" name="gdlb-submit" value="1" />
        <script>
            gdlbImageSelection(<?php echo $badge; ?>);
        </script>
        
<?php
    }
    
    function make_badge($badge_id = 0, $badge_url, $badge_text) {
        $linked_img = "http://www.linkedin.com/img/webpromo/";
        $badge_array = $this->badges[$badge_id];
        return '<div style="text-align: center;"><a href="'.$badge_url.'"><img src="'.$linked_img.$badge_array[1].'" border="0" alt="'.$badge_text.'" /></a></div>';
    }
    
    function make_options($selected = 0) {
        for ($i = 0; $i < count($this->badges); $i++) {
            $badge_array = $this->badges[$i];
            if ($selected == $i) 
                $current = ' selected="selected"';
            else 
                $current = '';
            echo "\n\t<option value='".$i."'".$current.">".$badge_array[0]."</option>";
        }
    }
}

$gdlb = new GDLinkedInBadge();
add_action('plugins_loaded', array($gdlb, 'init'));

?>